' Copyright (c) 2008  Future Technology Devices International Ltd.
'
' Module Name
'
'     MainForm.vb
'
' Abstract:
'
'    Visual Basic program, to test the FTCJTAG.DLL. The FTCJTAG.DLL is used to control the FT2232H dual hi-speed device
'    and the FT4232H quad hi-speed device to simulate the Joint Test Action Group(JTAG) synchronous protocol to
'    communicate with JTAG devices connected to FT2232H dual hi-speed devices and FT4232H quad hi-speed devices.
'
' Revision History:
'
'   21/07/08    Kirke Ashton    Created.
'
Public Class MainForm
    Inherits System.Windows.Forms.Form

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer
    Friend WithEvents DLLVersionLabel As System.Windows.Forms.Label
    Friend WithEvents PassFailureStatusStrip As System.Windows.Forms.StatusStrip
    Friend WithEvents PassFailStatusLabel As System.Windows.Forms.ToolStripStatusLabel
    Friend WithEvents PassFailResultsStatusLabel As System.Windows.Forms.ToolStripStatusLabel
    Friend WithEvents MainMenuStrip As System.Windows.Forms.MenuStrip
    Friend WithEvents OptionsMenuItem As System.Windows.Forms.ToolStripMenuItem
    Friend WithEvents CommandSequenceMenuItem As System.Windows.Forms.ToolStripMenuItem
    Friend WithEvents ToolStripSeparator1 As System.Windows.Forms.ToolStripSeparator
    Friend WithEvents ExitMenuItem As System.Windows.Forms.ToolStripMenuItem
    Friend WithEvents DeviceNameLabel As System.Windows.Forms.Label
    Friend WithEvents ChannelComboBox As System.Windows.Forms.ComboBox
    Friend WithEvents ChannelLabel As System.Windows.Forms.Label
    Friend WithEvents HiSpeedDeviceTypeGroupBox As System.Windows.Forms.GroupBox
    Friend WithEvents FT2232HRadioButton As System.Windows.Forms.RadioButton
    Friend WithEvents FT4232HRadioButton As System.Windows.Forms.RadioButton

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Friend WithEvents TestButton As System.Windows.Forms.Button


    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Dim resources As System.ComponentModel.ComponentResourceManager = New System.ComponentModel.ComponentResourceManager(GetType(MainForm))
        Me.TestButton = New System.Windows.Forms.Button
        Me.DLLVersionLabel = New System.Windows.Forms.Label
        Me.PassFailureStatusStrip = New System.Windows.Forms.StatusStrip
        Me.PassFailStatusLabel = New System.Windows.Forms.ToolStripStatusLabel
        Me.PassFailResultsStatusLabel = New System.Windows.Forms.ToolStripStatusLabel
        Me.MainMenuStrip = New System.Windows.Forms.MenuStrip
        Me.OptionsMenuItem = New System.Windows.Forms.ToolStripMenuItem
        Me.CommandSequenceMenuItem = New System.Windows.Forms.ToolStripMenuItem
        Me.ToolStripSeparator1 = New System.Windows.Forms.ToolStripSeparator
        Me.ExitMenuItem = New System.Windows.Forms.ToolStripMenuItem
        Me.DeviceNameLabel = New System.Windows.Forms.Label
        Me.ChannelComboBox = New System.Windows.Forms.ComboBox
        Me.ChannelLabel = New System.Windows.Forms.Label
        Me.HiSpeedDeviceTypeGroupBox = New System.Windows.Forms.GroupBox
        Me.FT4232HRadioButton = New System.Windows.Forms.RadioButton
        Me.FT2232HRadioButton = New System.Windows.Forms.RadioButton
        Me.PassFailureStatusStrip.SuspendLayout()
        Me.MainMenuStrip.SuspendLayout()
        Me.HiSpeedDeviceTypeGroupBox.SuspendLayout()
        Me.SuspendLayout()
        '
        'TestButton
        '
        Me.TestButton.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.TestButton.Location = New System.Drawing.Point(543, 248)
        Me.TestButton.Name = "TestButton"
        Me.TestButton.Size = New System.Drawing.Size(72, 24)
        Me.TestButton.TabIndex = 0
        Me.TestButton.Text = "Test"
        '
        'DLLVersionLabel
        '
        Me.DLLVersionLabel.AutoSize = True
        Me.DLLVersionLabel.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.DLLVersionLabel.Location = New System.Drawing.Point(26, 43)
        Me.DLLVersionLabel.Name = "DLLVersionLabel"
        Me.DLLVersionLabel.Size = New System.Drawing.Size(222, 13)
        Me.DLLVersionLabel.TabIndex = 1
        Me.DLLVersionLabel.Text = "FT2232/FT4232 JTAG DLL Version = "
        '
        'PassFailureStatusStrip
        '
        Me.PassFailureStatusStrip.Items.AddRange(New System.Windows.Forms.ToolStripItem() {Me.PassFailStatusLabel, Me.PassFailResultsStatusLabel})
        Me.PassFailureStatusStrip.Location = New System.Drawing.Point(0, 293)
        Me.PassFailureStatusStrip.Name = "PassFailureStatusStrip"
        Me.PassFailureStatusStrip.Size = New System.Drawing.Size(644, 22)
        Me.PassFailureStatusStrip.TabIndex = 3
        Me.PassFailureStatusStrip.Text = "Pass/Failure Status"
        '
        'PassFailStatusLabel
        '
        Me.PassFailStatusLabel.BorderSides = System.Windows.Forms.ToolStripStatusLabelBorderSides.Right
        Me.PassFailStatusLabel.Font = New System.Drawing.Font("Tahoma", 8.25!, System.Drawing.FontStyle.Bold)
        Me.PassFailStatusLabel.Name = "PassFailStatusLabel"
        Me.PassFailStatusLabel.Size = New System.Drawing.Size(121, 17)
        Me.PassFailStatusLabel.Text = "Pass/Failure Status"
        '
        'PassFailResultsStatusLabel
        '
        Me.PassFailResultsStatusLabel.Name = "PassFailResultsStatusLabel"
        Me.PassFailResultsStatusLabel.Size = New System.Drawing.Size(0, 17)
        '
        'MainMenuStrip
        '
        Me.MainMenuStrip.Items.AddRange(New System.Windows.Forms.ToolStripItem() {Me.OptionsMenuItem})
        Me.MainMenuStrip.Location = New System.Drawing.Point(0, 0)
        Me.MainMenuStrip.Name = "MainMenuStrip"
        Me.MainMenuStrip.Size = New System.Drawing.Size(644, 24)
        Me.MainMenuStrip.TabIndex = 4
        '
        'OptionsMenuItem
        '
        Me.OptionsMenuItem.DropDownItems.AddRange(New System.Windows.Forms.ToolStripItem() {Me.CommandSequenceMenuItem, Me.ToolStripSeparator1, Me.ExitMenuItem})
        Me.OptionsMenuItem.Name = "OptionsMenuItem"
        Me.OptionsMenuItem.Size = New System.Drawing.Size(56, 20)
        Me.OptionsMenuItem.Text = "Options"
        '
        'CommandSequenceMenuItem
        '
        Me.CommandSequenceMenuItem.Checked = True
        Me.CommandSequenceMenuItem.CheckState = System.Windows.Forms.CheckState.Checked
        Me.CommandSequenceMenuItem.Name = "CommandSequenceMenuItem"
        Me.CommandSequenceMenuItem.Size = New System.Drawing.Size(171, 22)
        Me.CommandSequenceMenuItem.Text = "Cmd Seq"
        '
        'ToolStripSeparator1
        '
        Me.ToolStripSeparator1.Name = "ToolStripSeparator1"
        Me.ToolStripSeparator1.Size = New System.Drawing.Size(168, 6)
        '
        'ExitMenuItem
        '
        Me.ExitMenuItem.Name = "ExitMenuItem"
        Me.ExitMenuItem.ShortcutKeys = CType(((System.Windows.Forms.Keys.Control Or System.Windows.Forms.Keys.Shift) _
                    Or System.Windows.Forms.Keys.E), System.Windows.Forms.Keys)
        Me.ExitMenuItem.Size = New System.Drawing.Size(171, 22)
        Me.ExitMenuItem.Text = "Exit"
        '
        'DeviceNameLabel
        '
        Me.DeviceNameLabel.AutoSize = True
        Me.DeviceNameLabel.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.DeviceNameLabel.Location = New System.Drawing.Point(26, 77)
        Me.DeviceNameLabel.Name = "DeviceNameLabel"
        Me.DeviceNameLabel.Size = New System.Drawing.Size(98, 13)
        Me.DeviceNameLabel.TabIndex = 5
        Me.DeviceNameLabel.Text = "Device Name = "
        '
        'ChannelComboBox
        '
        Me.ChannelComboBox.FormattingEnabled = True
        Me.ChannelComboBox.Location = New System.Drawing.Point(569, 40)
        Me.ChannelComboBox.Name = "ChannelComboBox"
        Me.ChannelComboBox.Size = New System.Drawing.Size(46, 21)
        Me.ChannelComboBox.TabIndex = 6
        '
        'ChannelLabel
        '
        Me.ChannelLabel.AutoSize = True
        Me.ChannelLabel.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.ChannelLabel.Location = New System.Drawing.Point(510, 43)
        Me.ChannelLabel.Name = "ChannelLabel"
        Me.ChannelLabel.Size = New System.Drawing.Size(53, 13)
        Me.ChannelLabel.TabIndex = 7
        Me.ChannelLabel.Text = "Channel"
        '
        'HiSpeedDeviceTypeGroupBox
        '
        Me.HiSpeedDeviceTypeGroupBox.Controls.Add(Me.FT4232HRadioButton)
        Me.HiSpeedDeviceTypeGroupBox.Controls.Add(Me.FT2232HRadioButton)
        Me.HiSpeedDeviceTypeGroupBox.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.HiSpeedDeviceTypeGroupBox.Location = New System.Drawing.Point(29, 107)
        Me.HiSpeedDeviceTypeGroupBox.Name = "HiSpeedDeviceTypeGroupBox"
        Me.HiSpeedDeviceTypeGroupBox.Size = New System.Drawing.Size(174, 50)
        Me.HiSpeedDeviceTypeGroupBox.TabIndex = 11
        Me.HiSpeedDeviceTypeGroupBox.TabStop = False
        Me.HiSpeedDeviceTypeGroupBox.Text = "Hi Speed Device Type"
        '
        'FT4232HRadioButton
        '
        Me.FT4232HRadioButton.AutoSize = True
        Me.FT4232HRadioButton.Enabled = False
        Me.FT4232HRadioButton.Location = New System.Drawing.Point(91, 20)
        Me.FT4232HRadioButton.Name = "FT4232HRadioButton"
        Me.FT4232HRadioButton.Size = New System.Drawing.Size(77, 17)
        Me.FT4232HRadioButton.TabIndex = 1
        Me.FT4232HRadioButton.TabStop = True
        Me.FT4232HRadioButton.Text = "FT4232H"
        Me.FT4232HRadioButton.UseVisualStyleBackColor = True
        '
        'FT2232HRadioButton
        '
        Me.FT2232HRadioButton.AutoSize = True
        Me.FT2232HRadioButton.Enabled = False
        Me.FT2232HRadioButton.Location = New System.Drawing.Point(7, 20)
        Me.FT2232HRadioButton.Name = "FT2232HRadioButton"
        Me.FT2232HRadioButton.Size = New System.Drawing.Size(77, 17)
        Me.FT2232HRadioButton.TabIndex = 0
        Me.FT2232HRadioButton.TabStop = True
        Me.FT2232HRadioButton.Text = "FT2232H"
        Me.FT2232HRadioButton.UseVisualStyleBackColor = True
        '
        'MainForm
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(644, 315)
        Me.Controls.Add(Me.HiSpeedDeviceTypeGroupBox)
        Me.Controls.Add(Me.ChannelLabel)
        Me.Controls.Add(Me.ChannelComboBox)
        Me.Controls.Add(Me.DeviceNameLabel)
        Me.Controls.Add(Me.PassFailureStatusStrip)
        Me.Controls.Add(Me.MainMenuStrip)
        Me.Controls.Add(Me.DLLVersionLabel)
        Me.Controls.Add(Me.TestButton)
        Me.Icon = CType(resources.GetObject("$this.Icon"), System.Drawing.Icon)
        Me.Name = "MainForm"
        Me.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen
        Me.Text = "Main Form"
        Me.PassFailureStatusStrip.ResumeLayout(False)
        Me.PassFailureStatusStrip.PerformLayout()
        Me.MainMenuStrip.ResumeLayout(False)
        Me.MainMenuStrip.PerformLayout()
        Me.HiSpeedDeviceTypeGroupBox.ResumeLayout(False)
        Me.HiSpeedDeviceTypeGroupBox.PerformLayout()
        Me.ResumeLayout(False)
        Me.PerformLayout()

    End Sub

#End Region

    Public Structure FTC_INPUT_OUTPUT_PINS
        Public bPin1InputOutputState As Boolean
        Public bPin1LowHighState As Boolean
        Public bPin2InputOutputState As Boolean
        Public bPin2LowHighState As Boolean
        Public bPin3InputOutputState As Boolean
        Public bPin3LowHighState As Boolean
        Public bPin4InputOutputState As Boolean
        Public bPin4LowHighState As Boolean
    End Structure

    Public Structure FTH_INPUT_OUTPUT_PINS
        Public bPin1InputOutputState As Boolean
        Public bPin1LowHighState As Boolean
        Public bPin2InputOutputState As Boolean
        Public bPin2LowHighState As Boolean
        Public bPin3InputOutputState As Boolean
        Public bPin3LowHighState As Boolean
        Public bPin4InputOutputState As Boolean
        Public bPin4LowHighState As Boolean
        Public bPin5InputOutputState As Boolean
        Public bPin5LowHighState As Boolean
        Public bPin6InputOutputState As Boolean
        Public bPin6LowHighState As Boolean
        Public bPin7InputOutputState As Boolean
        Public bPin7LowHighState As Boolean
        Public bPin8InputOutputState As Boolean
        Public bPin8LowHighState As Boolean
    End Structure

    Public Structure FTC_LOW_HIGH_PINS
        Public bPin1LowHighState As Boolean
        Public bPin2LowHighState As Boolean
        Public bPin3LowHighState As Boolean
        Public bPin4LowHighState As Boolean
    End Structure

    Public Structure FTH_LOW_HIGH_PINS
        Public bPin1LowHighState As Boolean
        Public bPin2LowHighState As Boolean
        Public bPin3LowHighState As Boolean
        Public bPin4LowHighState As Boolean
        Public bPin5LowHighState As Boolean
        Public bPin6LowHighState As Boolean
        Public bPin7LowHighState As Boolean
        Public bPin8LowHighState As Boolean
    End Structure

    Public Structure FTC_CLOSE_FINAL_STATE_PINS
        Public bTCKPinState As Boolean
        Public bTCKPinActiveState As Boolean
        Public bTDIPinState As Boolean
        Public bTDIPinActiveState As Boolean
        Public bTMSPinState As Boolean
        Public bTMSPinActiveState As Boolean
    End Structure

    Private Declare Function JTAG_GetNumHiSpeedDevices Lib "ftcjtag" (ByRef NumHiSpeedDevices As Long) As Integer
    Private Declare Function JTAG_GetHiSpeedDeviceNameLocIDChannel Lib "ftcjtag" (ByVal DeviceNameIndex As Integer, ByVal DeviceName As String, ByVal DeviceNameBufferSize As Integer, ByRef lpLocationID As Long, ByVal Channel As String, ByVal ChannelBufferSize As Integer, ByRef lpHiSpeedDeviceType As Long) As Integer
    Private Declare Function JTAG_OpenHiSpeedDevice Lib "ftcjtag" (ByVal DeviceName As String, ByVal LocationID As Integer, ByVal Channel As String, ByRef ftHandle As Long) As Integer
    Private Declare Function JTAG_Close Lib "ftcjtag" (ByVal ftHandle As Integer) As Integer
    Private Declare Function JTAG_CloseDevice Lib "ftcjtag" (ByVal ftHandle As Integer, ByRef pCloseFinalStatePinsData As FTC_CLOSE_FINAL_STATE_PINS) As Integer
    Private Declare Function JTAG_GetHiSpeedDeviceType Lib "ftcjtag" (ByVal ftHandle As Integer, ByRef lpHiSpeedDeviceType As Long) As Integer
    Private Declare Function JTAG_InitDevice Lib "ftcjtag" (ByVal ftHandle As Integer, ByVal ClockDivisor As Integer) As Integer
    Private Declare Function JTAG_TurnOnDivideByFiveClockingHiSpeedDevice Lib "ftcjtag" (ByVal ftHandle As Integer) As Integer
    Private Declare Function JTAG_TurnOffDivideByFiveClockingHiSpeedDevice Lib "ftcjtag" (ByVal ftHandle As Integer) As Integer
    Private Declare Function JTAG_TurnOnAdaptiveClockingHiSpeedDevice Lib "ftcjtag" (ByVal ftHandle As Integer) As Integer
    Private Declare Function JTAG_TurnOffAdaptiveClockingHiSpeedDevice Lib "ftcjtag" (ByVal ftHandle As Integer) As Integer
    Private Declare Function JTAG_SetDeviceLatencyTimer Lib "ftcjtag" (ByVal ftHandle As Integer, ByVal TimerValue As Byte) As Integer
    Private Declare Function JTAG_GetDeviceLatencyTimer Lib "ftcjtag" (ByVal ftHandle As Integer, ByRef lpTimerValue As Byte) As Integer
    Private Declare Function JTAG_GetHiSpeedDeviceClock Lib "ftcjtag" (ByVal ClockDivisor As Integer, ByRef lpClockFrequencyHz As Long) As Integer
    Private Declare Function JTAG_GetClock Lib "ftcjtag" (ByVal ClockDivisor As Integer, ByRef lpClockFrequencyHz As Long) As Integer
    Private Declare Function JTAG_SetClock Lib "ftcjtag" (ByVal ftHandle As Integer, ByVal ClockDivisor As Integer, ByRef lpClockFrequencyHz As Long) As Integer
    Private Declare Function JTAG_SetLoopback Lib "ftcjtag" (ByVal ftHandle As Integer, ByVal bLoopbackState As Boolean) As Integer
    Private Declare Function JTAG_SetGPIOs Lib "ftcjtag" (ByVal ftHandle As Integer, ByVal bControlLowInputOutputPins As Boolean, ByRef pLowInputOutputPinsData As FTC_INPUT_OUTPUT_PINS, ByVal bControlHighInputOutputPins As Boolean, ByRef pHighInputOutputPinsData As FTC_INPUT_OUTPUT_PINS) As Integer
    Private Declare Function JTAG_SetHiSpeedDeviceGPIOs Lib "ftcjtag" (ByVal ftHandle As Integer, ByVal bControlLowInputOutputPins As Boolean, ByRef pLowInputOutputPinsData As FTC_INPUT_OUTPUT_PINS, ByVal bControlHighInputOutputPins As Boolean, ByRef pHighInputOutputPinsData As FTH_INPUT_OUTPUT_PINS) As Integer
    Private Declare Function JTAG_GetGPIOs Lib "ftcjtag" (ByVal ftHandle As Integer, ByVal bControlLowInputOutputPins As Boolean, ByRef pLowPinsInputData As FTC_LOW_HIGH_PINS, ByVal bControlHighInputOutputPins As Boolean, ByRef pHighPinsInputData As FTC_LOW_HIGH_PINS) As Integer
    Private Declare Function JTAG_GetHiSpeedDeviceGPIOs Lib "ftcjtag" (ByVal ftHandle As Integer, ByVal bControlLowInputOutputPins As Boolean, ByRef pLowPinsInputData As FTC_LOW_HIGH_PINS, ByVal bControlHighInputOutputPins As Boolean, ByRef pHighPinsInputData As FTH_LOW_HIGH_PINS) As Integer
    Private Declare Function JTAG_Write Lib "ftcjtag" (ByVal ftHandle As Integer, ByVal bInstructionTestData As Boolean, ByVal NumBitsToWrite As Integer, ByVal WriteDataBuffer() As Byte, ByVal NumBytesToWrite As Integer, ByVal TapControllerState As Integer) As Integer
    Private Declare Function JTAG_Read Lib "ftcjtag" (ByVal ftHandle As Integer, ByVal bInstructionTestData As Boolean, ByVal NumBitsToRead As Integer, ByVal ReadDataBuffer() As Byte, ByRef lpNumBytesReturned As Long, ByVal TapControllerState As Integer) As Integer
    Private Declare Function JTAG_WriteRead Lib "ftcjtag" (ByVal ftHandle As Integer, ByVal bInstructionTestData As Boolean, ByVal NumBitsToWriteRead As Integer, ByVal WriteDataBuffer() As Byte, ByVal NumBytesToWrite As Integer, ByVal ReadDataBuffer() As Byte, ByRef lpNumBytesReturned As Long, ByVal TapControllerState As Integer) As Integer
    Private Declare Function JTAG_ClearCmdSequence Lib "ftcjtag" () As Integer
    Private Declare Function JTAG_AddWriteCmd Lib "ftcjtag" (ByVal bInstructionTestData As Boolean, ByVal NumBitsToWrite As Integer, ByVal WriteDataBuffer() As Byte, ByVal NumBytesToWrite As Integer, ByVal TapControllerState As Integer) As Integer
    Private Declare Function JTAG_AddReadCmd Lib "ftcjtag" (ByVal bInstructionTestData As Boolean, ByVal NumBitsToRead As Integer, ByVal TapControllerState As Integer) As Integer
    Private Declare Function JTAG_AddWriteReadCmd Lib "ftcjtag" (ByVal bInstructionTestData As Boolean, ByVal NumBitsToWriteRead As Integer, ByVal WriteDataBuffer() As Byte, ByVal NumBytesToWrite As Integer, ByVal TapControllerState As Integer) As Integer
    Private Declare Function JTAG_ClearDeviceCmdSequence Lib "ftcjtag" (ByVal ftHandle As Integer) As Integer
    Private Declare Function JTAG_AddDeviceWriteCmd Lib "ftcjtag" (ByVal ftHandle As Integer, ByVal bInstructionTestData As Boolean, ByVal NumBitsToWrite As Integer, ByVal WriteDataBuffer() As Byte, ByVal NumBytesToWrite As Integer, ByVal TapControllerState As Integer) As Integer
    Private Declare Function JTAG_AddDeviceReadCmd Lib "ftcjtag" (ByVal ftHandle As Integer, ByVal bInstructionTestData As Boolean, ByVal NumBitsToRead As Integer, ByVal TapControllerState As Integer) As Integer
    Private Declare Function JTAG_AddDeviceWriteReadCmd Lib "ftcjtag" (ByVal ftHandle As Integer, ByVal bInstructionTestData As Boolean, ByVal NumBitsToWriteRead As Integer, ByVal WriteDataBuffer() As Byte, ByVal NumBytesToWrite As Integer, ByVal TapControllerState As Integer) As Integer
    Private Declare Function JTAG_ExecuteCmdSequence Lib "ftcjtag" (ByVal ftHandle As Integer, ByVal ReadCmdSequenceDataBuffer() As Byte, ByRef lpNumBytesReturned As Long) As Integer
    'Private Declare Function JTAG_GetDllVersion Lib "ftcjtag" (ByVal DllVersion As String, ByVal BufferSize As Integer) As Integer
    Private Declare Function GetDllVersion Lib "ftcjtag" Alias "JTAG_GetDllVersion" (ByVal DllVersion As String, ByVal BufferSize As Integer) As Integer
    Private Declare Function JTAG_GetErrorCodeString Lib "ftcjtag" (ByVal Language As String, ByVal StatusCode As Integer, ByVal ErrorMessage As String, ByVal BufferSize As Integer) As Integer

    Private Declare Function Sleep Lib "Kernel32" (ByVal Milliseconds As Integer) As Long

    Private Const FTC_SUCCESS = 0
    Private Const FTC_DEVICE_IN_USE = 27

    Private Const TEST_LOGIC_STATE = 1
    Private Const RUN_TEST_IDLE_STATE = 2
    Private Const PAUSE_TEST_DATA_REGISTER_STATE = 3
    Private Const PAUSE_INSTRUCTION_REGISTER_STATE = 4
    Private Const SHIFT_TEST_DATA_REGISTER_STATE = 5
    Private Const SHIFT_INSTRUCTION_REGISTER_STATE = 6

    Private Const WRITE_DATA_BUFFER_SIZE = 65536
    Private Const READ_DATA_BUFFER_SIZE = 65536
    Private Const READ_CMDS_DATA_BUFFER_SIZE = 131071

    Private Const MAX_NUM_DEVICE_NAME_CHARS = 100
    Private Const MAX_NUM_CHANNEL_CHARS = 5

    Private Const MAX_NUM_DLL_VERSION_CHARS = 10

    Private Const MAX_NUM_ERROR_MESSAGE_CHARS = 100

    Private Const App_Title = "FT2232/FT4232 Hi-Speed JTAG Device Visual Basic .NET Test Application"

    Private Const Dll_Version_Label = "FT2232/FT4232 JTAG DLL Version = "

    Private Const Device_Name_Label = "Device Name = "

    Private Enum hiSpeedDeviceTypes
        FT2232H_Device_Type = 1
        FT4232H_Device_Type = 2
    End Enum

    Private Const Pass_Fail_Label = "Pass/Failure = "

    Private bExecutingTest As Boolean = False

    Private bHiSpeedDeviceTypeChanged As Boolean = False

    Private ftHandle As Integer = 0

    Private Function ConvertDLLStringToVBString(ByRef DLLString As String) As String
        Dim VBString As String
        Dim iCharCntr As Integer = 0
        Dim CharArray() As Char

        While (DLLString.Chars(iCharCntr) <> vbNullChar)
            iCharCntr = iCharCntr + 1
        End While

        CharArray = New Char((iCharCntr - 1)) {}

        iCharCntr = 0
        While (DLLString.Chars(iCharCntr) <> vbNullChar)
            CharArray(iCharCntr) = DLLString.Chars(iCharCntr)
            iCharCntr = iCharCntr + 1
        End While

        VBString = New String(CharArray)

        Return VBString
    End Function

    Private Function TestHiSpeedDeviceClock(ByVal ftHandle As Integer) As Integer
        Dim ftStatus As Integer = FTC_SUCCESS
        Dim ClockFrequencyHz As Long = 0

        ftStatus = JTAG_GetHiSpeedDeviceClock(0, ClockFrequencyHz)

        If (ftStatus = FTC_SUCCESS) Then
            ftStatus = JTAG_TurnOnDivideByFiveClockingHiSpeedDevice(ftHandle)

            If (ftStatus = FTC_SUCCESS) Then
                ftStatus = JTAG_GetHiSpeedDeviceClock(0, ClockFrequencyHz)

                ftStatus = JTAG_SetClock(ftHandle, 0, ClockFrequencyHz)

                If (ftStatus = FTC_SUCCESS) Then
                    ftStatus = JTAG_TurnOffDivideByFiveClockingHiSpeedDevice(ftHandle)

                    ftStatus = JTAG_SetClock(ftHandle, 1, ClockFrequencyHz)
                End If
            End If
        End If

        Return ftStatus
    End Function
    Private Sub TestButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TestButton.Click
        Dim ftStatus As Integer = FTC_SUCCESS
        Dim NumHiSpeedDevices As Long = 0
        Dim HiSpeedDeviceName As String = New String(ChrW(0), MAX_NUM_DEVICE_NAME_CHARS)
        Dim HiSpeedDeviceChannel As String = New String(ChrW(0), MAX_NUM_CHANNEL_CHARS)
        Dim LocationID As Long = 0
        Dim HiSpeedDeviceType As Long = 0
        Dim HSDN As String
        Dim HSCH As String
        Dim HiSpeedDeviceIndex As Long = 0
        Dim TimerValue As Byte = 0
        Dim bLoopbackState As Boolean = False
        Dim LowInputOutputPinsData As FTC_INPUT_OUTPUT_PINS
        Dim HighInputOutputPinsData As FTH_INPUT_OUTPUT_PINS
        Dim LowPinsInputData As FTC_LOW_HIGH_PINS
        Dim HighPinsInputData As FTH_LOW_HIGH_PINS
        Dim CloseFinalStatePinsData As FTC_CLOSE_FINAL_STATE_PINS
        Dim WriteDataBuffer() As Byte = New Byte((WRITE_DATA_BUFFER_SIZE - 1)) {}
        Dim ReadDataBuffer() As Byte = New Byte((READ_DATA_BUFFER_SIZE - 1)) {}
        Dim ReadCmdSequenceDataBuffer() As Byte = New Byte((READ_CMDS_DATA_BUFFER_SIZE - 1)) {}
        Dim NumBytesReturned As Long = 0
        Dim iLoopCntr As Integer = 0
        Dim mismatchMsg As String = vbNullString
        Dim style As MsgBoxStyle = MsgBoxStyle.OkCancel
        Dim response As MsgBoxResult = MsgBoxResult.Ok

        Dim StatusErrorMessage As String = New String(ChrW(0), MAX_NUM_ERROR_MESSAGE_CHARS)
        Dim ErrorMessage As String

        bExecutingTest = True

        Dim DllVersion As String = New String(ChrW(0), MAX_NUM_DLL_VERSION_CHARS)
        ftStatus = GetDllVersion(DllVersion, MAX_NUM_DLL_VERSION_CHARS)
        Me.DLLVersionLabel.Text = Dll_Version_Label + DllVersion
        Me.DLLVersionLabel.Refresh()
        'MsgBox(DllVersion)

        Me.DeviceNameLabel.Text = Device_Name_Label
        Me.DeviceNameLabel.Refresh()

        Me.FT2232HRadioButton.Checked = CheckState.Unchecked
        Me.FT4232HRadioButton.Checked = CheckState.Unchecked

        Me.PassFailResultsStatusLabel.Text = ""
        Me.PassFailureStatusStrip.Refresh()
        Sleep(1000)

        ftStatus = JTAG_GetNumHiSpeedDevices(NumHiSpeedDevices)

        If ((ftStatus = FTC_SUCCESS) And (NumHiSpeedDevices > 0)) Then

            Do
                ftStatus = JTAG_GetHiSpeedDeviceNameLocIDChannel(HiSpeedDeviceIndex, HiSpeedDeviceName, MAX_NUM_DEVICE_NAME_CHARS, LocationID, HiSpeedDeviceChannel, MAX_NUM_CHANNEL_CHARS, HiSpeedDeviceType)

                If (ftStatus = FTC_SUCCESS) Then
                    HSCH = New String(ConvertDLLStringToVBString(HiSpeedDeviceChannel))
                End If

                HiSpeedDeviceIndex = HiSpeedDeviceIndex + 1
            Loop While ((ftStatus = FTC_SUCCESS) And (HiSpeedDeviceIndex < NumHiSpeedDevices) And ((HSCH <> vbNullString) And (HSCH <> Me.ChannelComboBox.Text)))

            If (ftStatus = FTC_SUCCESS) Then
                If ((HSCH <> vbNullString) And (HSCH <> Me.ChannelComboBox.Text)) Then
                    ftStatus = FTC_DEVICE_IN_USE
                End If
            End If

            If (ftStatus = FTC_SUCCESS) Then
                HSDN = New String(ConvertDLLStringToVBString(HiSpeedDeviceName))
                ftStatus = JTAG_OpenHiSpeedDevice(HSDN, LocationID, HSCH, ftHandle)

                Me.DeviceNameLabel.Text = Device_Name_Label + HSDN
                Me.DeviceNameLabel.Refresh()

                If (ftStatus = FTC_SUCCESS) Then
                    ftStatus = JTAG_GetHiSpeedDeviceType(ftHandle, HiSpeedDeviceType)

                    If (ftStatus = FTC_SUCCESS) Then
                        If (HiSpeedDeviceType = hiSpeedDeviceTypes.FT4232H_Device_Type) Then
                            Me.FT4232HRadioButton.Checked = CheckState.Checked 'True
                        ElseIf (HiSpeedDeviceType = hiSpeedDeviceTypes.FT2232H_Device_Type) Then
                            Me.FT2232HRadioButton.Checked = CheckState.Checked 'True
                        End If
                    End If
                End If
            End If
        End If

        If ((ftHandle <> 0) And (ftStatus = FTC_SUCCESS)) Then
            ftStatus = JTAG_InitDevice(ftHandle, 0)

            If (ftStatus = FTC_SUCCESS) Then
                'ftStatus = JTAG_TurnOnAdaptiveClockingHiSpeedDevice(ftHandle)

                'ftStatus = JTAG_TurnOffAdaptiveClockingHiSpeedDevice(ftHandle)
            End If

            If (ftStatus = FTC_SUCCESS) Then
                ftStatus = JTAG_GetDeviceLatencyTimer(ftHandle, TimerValue)

                If (ftStatus = FTC_SUCCESS) Then
                    ftStatus = JTAG_SetDeviceLatencyTimer(ftHandle, 50)

                    If (ftStatus = FTC_SUCCESS) Then
                        ftStatus = JTAG_GetDeviceLatencyTimer(ftHandle, TimerValue)

                        ftStatus = JTAG_SetDeviceLatencyTimer(ftHandle, 16)

                        ftStatus = JTAG_GetDeviceLatencyTimer(ftHandle, TimerValue)
                    End If
                End If
            End If

            If (ftStatus = FTC_SUCCESS) Then
                ftStatus = TestHiSpeedDeviceClock(ftHandle)
            End If

            If (ftStatus = FTC_SUCCESS) Then
                ftStatus = JTAG_SetLoopback(ftHandle, False)
            End If

            If (ftStatus = FTC_SUCCESS) Then
                LowInputOutputPinsData.bPin1InputOutputState = True
                LowInputOutputPinsData.bPin2InputOutputState = True
                LowInputOutputPinsData.bPin3InputOutputState = True
                LowInputOutputPinsData.bPin4InputOutputState = True
                LowInputOutputPinsData.bPin1LowHighState = True
                LowInputOutputPinsData.bPin2LowHighState = False
                LowInputOutputPinsData.bPin3LowHighState = True
                LowInputOutputPinsData.bPin4LowHighState = True

                If (HiSpeedDeviceType = hiSpeedDeviceTypes.FT2232H_Device_Type) Then
                    HighInputOutputPinsData.bPin1InputOutputState = True
                    HighInputOutputPinsData.bPin2InputOutputState = True
                    HighInputOutputPinsData.bPin3InputOutputState = True
                    HighInputOutputPinsData.bPin4InputOutputState = True
                    HighInputOutputPinsData.bPin5InputOutputState = True
                    HighInputOutputPinsData.bPin6InputOutputState = True
                    HighInputOutputPinsData.bPin7InputOutputState = True
                    HighInputOutputPinsData.bPin8InputOutputState = True
                    HighInputOutputPinsData.bPin1LowHighState = True
                    HighInputOutputPinsData.bPin2LowHighState = True
                    HighInputOutputPinsData.bPin3LowHighState = False
                    HighInputOutputPinsData.bPin4LowHighState = True
                    HighInputOutputPinsData.bPin5LowHighState = True
                    HighInputOutputPinsData.bPin6LowHighState = True
                    HighInputOutputPinsData.bPin7LowHighState = False
                    HighInputOutputPinsData.bPin8LowHighState = True

                    ftStatus = JTAG_SetHiSpeedDeviceGPIOs(ftHandle, True, LowInputOutputPinsData, True, HighInputOutputPinsData)
                Else
                    ftStatus = JTAG_SetHiSpeedDeviceGPIOs(ftHandle, True, LowInputOutputPinsData, False, HighInputOutputPinsData)
                End If


                If (ftStatus = FTC_SUCCESS) Then
                    If (HiSpeedDeviceType = hiSpeedDeviceTypes.FT2232H_Device_Type) Then
                        ftStatus = JTAG_GetHiSpeedDeviceGPIOs(ftHandle, True, LowPinsInputData, True, HighPinsInputData)
                    Else
                        ftStatus = JTAG_GetHiSpeedDeviceGPIOs(ftHandle, True, LowPinsInputData, False, HighPinsInputData)
                    End If
                End If

                If (ftStatus = FTC_SUCCESS) Then
                    WriteDataBuffer(0) = &H1
                    WriteDataBuffer(1) = &H1
                    WriteDataBuffer(2) = &H1
                    WriteDataBuffer(3) = &H1

                    If (Me.CommandSequenceMenuItem.CheckState = CheckState.Unchecked) Then
                        Do
                            ftStatus = JTAG_Write(ftHandle, True, 32, WriteDataBuffer, 4, RUN_TEST_IDLE_STATE)

                            If (ftStatus = FTC_SUCCESS) Then
                                Sleep(10)

                                ftStatus = JTAG_Read(ftHandle, True, 32, ReadDataBuffer, NumBytesReturned, RUN_TEST_IDLE_STATE)

                                If (ftStatus = FTC_SUCCESS) Then
                                    ftStatus = JTAG_WriteRead(ftHandle, True, 32, WriteDataBuffer, 4, ReadDataBuffer, NumBytesReturned, RUN_TEST_IDLE_STATE)

                                    If (ftStatus = FTC_SUCCESS) Then
                                        If ((WriteDataBuffer(0) <> ReadDataBuffer(0)) Or (WriteDataBuffer(1) <> ReadDataBuffer(1)) Or (WriteDataBuffer(2) <> ReadDataBuffer(2)) Or (WriteDataBuffer(3) <> ReadDataBuffer(3))) Then
                                            Dim mismatchValue As Byte = 0

                                            If (WriteDataBuffer(0) <> ReadDataBuffer(0)) Then
                                                mismatchValue = ReadDataBuffer(0)
                                            ElseIf (WriteDataBuffer(1) <> ReadDataBuffer(1)) Then
                                                mismatchValue = ReadDataBuffer(1)
                                            ElseIf (WriteDataBuffer(2) <> ReadDataBuffer(2)) Then
                                                mismatchValue = ReadDataBuffer(2)
                                            ElseIf (WriteDataBuffer(3) <> ReadDataBuffer(3)) Then
                                                mismatchValue = ReadDataBuffer(3)
                                            End If

                                            mismatchMsg = String.Format("JTAG Write/Read mismatch, Loop = {0}, Write Value = {1}, Read Value = {2}", iLoopCntr, 1, mismatchValue)

                                            response = MsgBox(mismatchMsg, style, "JTAG Read Error Message")
                                        End If
                                    End If
                                End If
                            End If

                            iLoopCntr = iLoopCntr + 1

                            Sleep(50)
                        Loop While ((iLoopCntr < 20) And (ftStatus = FTC_SUCCESS) And (response = MsgBoxResult.Ok))
                    Else
                        If (NumHiSpeedDevices = 1) Then
                            ftStatus = JTAG_ClearCmdSequence()

                            Do
                                ftStatus = JTAG_AddWriteCmd(True, 32, WriteDataBuffer, 4, RUN_TEST_IDLE_STATE)

                                If (ftStatus = FTC_SUCCESS) Then
                                    ftStatus = JTAG_AddReadCmd(True, 32, RUN_TEST_IDLE_STATE)
                                End If

                                If (ftStatus = FTC_SUCCESS) Then
                                    ftStatus = JTAG_AddWriteReadCmd(True, 32, WriteDataBuffer, 4, RUN_TEST_IDLE_STATE)
                                End If

                                iLoopCntr = iLoopCntr + 1
                            Loop While ((iLoopCntr < 4) And (ftStatus = FTC_SUCCESS))
                        Else
                            ftStatus = JTAG_ClearDeviceCmdSequence(ftHandle)

                            Do
                                ftStatus = JTAG_AddDeviceWriteCmd(ftHandle, True, 32, WriteDataBuffer, 4, RUN_TEST_IDLE_STATE)

                                If (ftStatus = FTC_SUCCESS) Then
                                    ftStatus = JTAG_AddDeviceReadCmd(ftHandle, True, 32, RUN_TEST_IDLE_STATE)
                                End If

                                If (ftStatus = FTC_SUCCESS) Then
                                    ftStatus = JTAG_AddDeviceWriteReadCmd(ftHandle, True, 32, WriteDataBuffer, 4, RUN_TEST_IDLE_STATE)
                                End If

                                iLoopCntr = iLoopCntr + 1
                            Loop While ((iLoopCntr < 4) And (ftStatus = FTC_SUCCESS))
                        End If

                        If (ftStatus = FTC_SUCCESS) Then
                            ftStatus = JTAG_ExecuteCmdSequence(ftHandle, ReadCmdSequenceDataBuffer, NumBytesReturned)
                        End If
                    End If
                End If
            End If
        End If

        If (ftHandle <> 0) Then
            'CloseFinalStatePinsData.bTCKPinState = True
            'CloseFinalStatePinsData.bTCKPinActiveState = True
            'CloseFinalStatePinsData.bTDIPinState = True
            'CloseFinalStatePinsData.bTDIPinActiveState = False
            'CloseFinalStatePinsData.bTMSPinState = True
            'CloseFinalStatePinsData.bTMSPinActiveState = True

            'ftStatus = JTAG_CloseDevice(ftHandle, CloseFinalStatePinsData)

            JTAG_Close(ftHandle)
            ftHandle = 0
        End If

        If ((ftStatus <> FTC_SUCCESS) Or (NumHiSpeedDevices = 0) Or (mismatchMsg <> vbNullString)) Then
            If (ftStatus <> FTC_SUCCESS) Then
                ErrorMessage = "Status Code(" + ftStatus.ToString + ") - "

                ftStatus = JTAG_GetErrorCodeString("EN", ftStatus, StatusErrorMessage, MAX_NUM_ERROR_MESSAGE_CHARS)

                ErrorMessage = ErrorMessage + New String(ConvertDLLStringToVBString(StatusErrorMessage))

                MsgBox(ErrorMessage)
            Else
                If (NumHiSpeedDevices = 0) Then
                    ErrorMessage = "There are no devices connected."

                    MsgBox(ErrorMessage)
                Else
                    ErrorMessage = mismatchMsg
                End If
            End If

            Me.PassFailResultsStatusLabel.Text = "Fail - " + ErrorMessage
            Me.PassFailureStatusStrip.Refresh()

            Console.WriteLine("Fail - " + ErrorMessage)
        Else
            Me.PassFailResultsStatusLabel.Text = "Pass"
            Me.PassFailureStatusStrip.Refresh()
        End If

        Beep()

        bExecutingTest = False
    End Sub

    Private Sub MainForm_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Me.Text = App_Title

        Me.CommandSequenceMenuItem.CheckState = CheckState.Unchecked

        Me.ChannelComboBox.Items.Clear()
        Me.ChannelComboBox.Items.Add("A")
        Me.ChannelComboBox.Items.Add("B")
        Me.ChannelComboBox.Text = "A"
        'Me.ChannelComboBox.SelectedIndex = -1
    End Sub

    Private Sub MainForm_Closing(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles MyBase.Closing
        Dim ftStatus As Integer = FTC_SUCCESS

        If (ftHandle <> 0) Then
            ftStatus = JTAG_Close(ftHandle)

            ftHandle = 0
        End If
    End Sub

    Private Sub CommandSequenceMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CommandSequenceMenuItem.Click
        If (Me.CommandSequenceMenuItem.CheckState = CheckState.Unchecked) Then
            Me.CommandSequenceMenuItem.CheckState = CheckState.Checked
        Else
            Me.CommandSequenceMenuItem.CheckState = CheckState.Unchecked
        End If
    End Sub

    Private Sub ExitMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ExitMenuItem.Click
        Me.Close()
    End Sub
End Class
